From: Jochen Sprickerhof <git@jochen.sprickerhof.de>
Date: Mon, 11 May 2015 15:48:01 +0200
Subject: =?utf-8?q?Add_support_for_Powerpc_=28Thanks_to_Roland_Stigge_and_?=
 =?utf-8?q?Fr=C3=A9d=C3=A9ric_Bonnard=29?=

---
 Platform/Linux/Build/Common/CommonDefs.mak   | 2 ++
 Platform/Linux/Build/Common/Platform.Powerpc | 9 +++++++++
 Platform/Linux/CreateRedist/RedistMaker      | 2 ++
 Source/Utils/XnSensorServer/SensorServer.cpp | 2 +-
 Source/XnDeviceSensorV2/XnDeviceSensorInit.h | 2 +-
 Source/XnDeviceSensorV2/XnSensorClient.cpp   | 2 +-
 6 files changed, 16 insertions(+), 3 deletions(-)
 create mode 100644 Platform/Linux/Build/Common/Platform.Powerpc

diff --git a/Platform/Linux/Build/Common/CommonDefs.mak b/Platform/Linux/Build/Common/CommonDefs.mak
index 11cb9d2..f5f50f5 100644
--- a/Platform/Linux/Build/Common/CommonDefs.mak
+++ b/Platform/Linux/Build/Common/CommonDefs.mak
@@ -15,6 +15,8 @@ else ifneq (,$(findstring i386,$(MACHINE)))
 	HOST_PLATFORM = x86
 else ifneq (,$(findstring arm,$(MACHINE)))
 	HOST_PLATFORM = Arm
+else ifneq (,$(findstring ppc,$(MACHINE)))
+	HOST_PLATFORM = Powerpc
 else
 	DUMMY:=$(error Can't determine host platform)
 endif
diff --git a/Platform/Linux/Build/Common/Platform.Powerpc b/Platform/Linux/Build/Common/Platform.Powerpc
new file mode 100644
index 0000000..8fe48e5
--- /dev/null
+++ b/Platform/Linux/Build/Common/Platform.Powerpc
@@ -0,0 +1,9 @@
+ifeq "$(CFG)" "Release"
+
+    # Optimization level, minus currently buggy optimizing methods (which break bit-exact)
+    CFLAGS += -O3 -fno-tree-pre -fno-strict-aliasing
+
+    # More optimization flags
+    CFLAGS += -ftree-vectorize -ffast-math -funsafe-math-optimizations -fsingle-precision-constant
+
+endif
diff --git a/Platform/Linux/CreateRedist/RedistMaker b/Platform/Linux/CreateRedist/RedistMaker
index 4d58a30..e2f3398 100644
--- a/Platform/Linux/CreateRedist/RedistMaker
+++ b/Platform/Linux/CreateRedist/RedistMaker
@@ -29,6 +29,8 @@ else
 		PLATFORM="x64" ;;
 	arm)
 		PLATFORM="Arm" ;;
+	ppc*)
+		PLATFORM="Powerpc" ;;
 	*)
 		echo "Unknown machine type: $MACHINE_TYPE"
 		exit 1
diff --git a/Source/Utils/XnSensorServer/SensorServer.cpp b/Source/Utils/XnSensorServer/SensorServer.cpp
index affc7a3..59043e3 100644
--- a/Source/Utils/XnSensorServer/SensorServer.cpp
+++ b/Source/Utils/XnSensorServer/SensorServer.cpp
@@ -56,7 +56,7 @@ int main(int argc, char* argv[])
 	nRetVal = XnSensorServerGetGlobalConfigFile(strConfigDir, strConfigFile, XN_FILE_MAX_PATH);
 	XN_CHECK_RC(nRetVal, "Resolving global config file");
 
-#if (XN_PLATFORM == XN_PLATFORM_LINUX_X86 || XN_PLATFORM == XN_PLATFORM_LINUX_ARM || XN_PLATFORM == XN_PLATFORM_MACOSX)
+#if (XN_PLATFORM == XN_PLATFORM_LINUX_X86 || XN_PLATFORM == XN_PLATFORM_LINUX_ARM || XN_PLATFORM == XN_PLATFORM_LINUX_POWERPC || XN_PLATFORM == XN_PLATFORM_MACOSX)
 	xnLogSetOutputFolder("/var/log/primesense/XnSensorServer/");
 #endif
 
diff --git a/Source/XnDeviceSensorV2/XnDeviceSensorInit.h b/Source/XnDeviceSensorV2/XnDeviceSensorInit.h
index 3de4773..7dbb4cb 100644
--- a/Source/XnDeviceSensorV2/XnDeviceSensorInit.h
+++ b/Source/XnDeviceSensorV2/XnDeviceSensorInit.h
@@ -57,7 +57,7 @@
 
 	#define XN_SENSOR_USB_MISC_BUFFER_SIZE	0x1000
 	#define XN_SENSOR_USB_MISC_BUFFERS		1
-#elif (XN_PLATFORM == XN_PLATFORM_LINUX_X86 || XN_PLATFORM == XN_PLATFORM_LINUX_ARM || XN_PLATFORM == XN_PLATFORM_MACOSX || XN_PLATFORM == XN_PLATFORM_ANDROID_ARM)
+#elif (XN_PLATFORM == XN_PLATFORM_LINUX_X86 || XN_PLATFORM == XN_PLATFORM_LINUX_ARM || XN_PLATFORM == XN_PLATFORM_LINUX_POWERPC || XN_PLATFORM == XN_PLATFORM_MACOSX || XN_PLATFORM == XN_PLATFORM_ANDROID_ARM)
 	#define XN_SENSOR_USB_IMAGE_BUFFER_SIZE_MULTIPLIER_ISO				32
 	#define XN_SENSOR_USB_IMAGE_BUFFER_SIZE_MULTIPLIER_BULK				40
 	#define XN_SENSOR_USB_IMAGE_BUFFER_SIZE_MULTIPLIER_LOWBAND_ISO		16
diff --git a/Source/XnDeviceSensorV2/XnSensorClient.cpp b/Source/XnDeviceSensorV2/XnSensorClient.cpp
index a010f3f..441962b 100644
--- a/Source/XnDeviceSensorV2/XnSensorClient.cpp
+++ b/Source/XnDeviceSensorV2/XnSensorClient.cpp
@@ -882,7 +882,7 @@ XnStatus XnSensorClient::StartServerProcess()
 	
 #if (XN_PLATFORM == XN_PLATFORM_WIN32)
 	nRetVal = GetModuleDir(strServerDir);
-#elif (XN_PLATFORM == XN_PLATFORM_LINUX_X86 || XN_PLATFORM == XN_PLATFORM_LINUX_ARM || XN_PLATFORM == XN_PLATFORM_MACOSX)
+#elif (XN_PLATFORM == XN_PLATFORM_LINUX_X86 || XN_PLATFORM == XN_PLATFORM_LINUX_ARM || XN_PLATFORM == XN_PLATFORM_LINUX_POWERPC || XN_PLATFORM == XN_PLATFORM_MACOSX)
 	sprintf(strServerDir, "/usr/lib/libopenni-sensor-primesense0");
 #endif
 
